import json
import tempfile
import os
import pprint
import tornado.web
from tornado.log import gen_log


_DOX_PREDICTOR = {'classifier': None}
def set_dox_predictor(predictor):
    _DOX_PREDICTOR['classifier'] = predictor


class ClassifyHandler(tornado.web.RequestHandler):

    def post(self):
        response = {"error": True, "msg": None}
        try:
            text = self.get_body_argument('text')
            report = json.loads(text)
            temp_file = tempfile.NamedTemporaryFile(delete=False)
            temp_file.write(report['text'].encode('utf8'))
            temp_file.close()
            prediction = _DOX_PREDICTOR['classifier'].predict([temp_file.name])
            os.unlink(temp_file.name)
            response['error'] = False
            response['msg'] = prediction[0]
        except ValueError, exc:
            response['msg'] = "Invalid JSON submitted as `text`\n{}".format(str(exc))
            gen_log.error("Error in prediction of text: %(msg)s", {
                "msg": pprint.pformat(response)
            })
            self.write(response)
            return
        except tornado.web.MissingArgumentError, exc:
            response['msg'] = "Missing POST argument '{}'".format(exc.arg_name)
            gen_log.error("Error in prediction of text: %(msg)s", {
                "msg": pprint.pformat(response)
            })
            self.write(response)
            return

        gen_log.debug("completed prediction of text: %(msg)s", {
            "msg": pprint.pformat(response)
        })
        self.write(response)
