import os
import logging
from logging.handlers import TimedRotatingFileHandler


def configure_logger(log_dir, debug):

    format_str = "%(asctime)s"

    if not log_dir:
        return

    if not os.path.exists(log_dir):
        os.makedirs(log_dir)

    log_file = os.path.join(log_dir, "dox-comment-extractor.log")
    log_handler = TimedRotatingFileHandler(log_file, when="midnight")
    log_formatter = logging.Formatter("%(created)f|%(message)s")
    log_handler.setFormatter(log_formatter)
    logger = logging.getLogger('dox-comment-extractor.log')
    logger.addHandler(log_handler)

    logger.info("dox-comment-extractor started.")

    logger.setLevel(logging.DEBUG if debug else logging.WARNING)
    logger.propagate = False
