import json
import pprint
import tornado.web
from tornado.log import gen_log
import doxextractor.personal as ep
import doxextractor.online as eo


TAGS_TO_MEASURE = (
    ('NAME:first', ep.first_name),
    ('NAME:last', ep.last_name),
    ('AGE', ep.age),
    ('PHONE', ep.phone),
    ('ONLINE:skype', eo.skype),
    ('ONLINE:ig', eo.instagram),
    ('ONLINE:twitter', eo.twitter),
    ('ONLINE:kik', eo.kik),
    ('ONLINE:yt', eo.youtube),
    ('ONLINE:gplus', eo.google_plus),
    ('ONLINE:fb', eo.facebook),
    ('ONLINE:twitch', eo.twitch),
)


class ExtractionHandler(tornado.web.RequestHandler):
    def post(self):
        response = {"error": True}
        try:
            test_text = self.get_body_argument('text')
            paste_record = json.loads(test_text)
            test_text = paste_record['text']
        except ValueError, exc:
            response['msg'] = "Invalid JSOn submitted as 'text'\n{}".format(str(exc))
            gen_log.error("Error in token extraction: %(msg)s", {
                "msg": pprint.pformat(response)
            })
            self.write(response)
            return
        except tornado.web.MissingArgumentError, exc:
            response['msg'] = "Missing POST argument '{}'".format(exc.arg_name)
            gen_log.error("Error in token extraction: %(msg)s", {
                "msg": pprint.pformat(response)
            })
            self.write(response)
            return

        result = {}
        for label, func in TAGS_TO_MEASURE:
            found_tokens = func(test_text)
            if found_tokens is None or len(found_tokens) == 0:
                continue
            result[label] = found_tokens
        response['msg'] = result
        response['error'] = False
        gen_log.debug("Extracted tokens for request: %(msg)s", {
            "msg": pprint.pformat(response),
        })
        self.write(response)
