#!/usr/bin/env python

import sys
import json
import doxextractor.tags as et
import doxextractor.personal as ep
import doxextractor.online as eo

tags_to_measure = (
    ('NAME:first', ep.first_name),
    ('NAME:last', ep.last_name),
    ('AGE', ep.age),
    ('PHONE', ep.phone),
    ('ONLINE:skype', eo.skype),
    ('ONLINE:ig', eo.instagram),
    ('ONLINE:twitter', eo.twitter),
    ('ONLINE:kik', eo.kik),
    ('ONLINE:yt', eo.youtube),
    ('ONLINE:gplus', eo.google_plus),
    ('ONLINE:fb', eo.facebook),
    ('ONLINE:twitch', eo.twitch),
)

all_text = "".join(sys.stdin)

result = {}
for label, func in tags_to_measure:
    found_tokens = func(all_text)
    if found_tokens is None or len(found_tokens) == 0:
        continue
    result[label] = found_tokens

sys.stdout.write(json.dumps(result))
